#include <File.au3>
#include <Array.au3>

#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <ProgressConstants.au3>
#include <WindowsConstants.au3>

#cs
1.0 = * Initial release.
#ce

Global $Version = "1.0"

Local $aArray_RomsListCleaned[0][2]

HotKeySet("+{ESC}", "_Quit")

MsgBox(0, "Tur-XML_Find_Dupe " & $Version & " by Turranius", "We will now ask you a number of questions." & @CRLF & @CRLF & "Please see the title of each box that pops up for what we are asking for." & @CRLF & @CRLF & "You can press Shift-Escape at any time to quit/abort (if there is a messagebox up, you have to click on it before it exits).")

Global $RomXML = FileOpenDialog("Select Database XML", "", "XML files (*.XML)", 1)
If $RomXML = "" Then
   MsgBox(16, "Error", "Got no XML location. Aborting")
   Exit
EndIf

Local $hFileOpen = FileOpen($RomXML, 0)
If $hFileOpen = -1 Then
   MsgBox(16, "", "An error occurred when reading the XML file.")
   Exit
EndIf
if "ADAM" = "adam" Then
   msgbox(0, "", "ost")
EndIf

$Rows = _FileCountLines($RomXML)
For $i = 1 to $Rows

   $line = FileReadLine($hFileOpen, $i)
   If StringinStr($line, "<game name=") Then
	  Local $GameNameArray = StringSplit($line, '"')
	  $RomName = $GameNameArray[2]

	  $DupeFound = "FALSE"
	  For $k = 0 To UBound($aArray_RomsListCleaned) - 1
		 $RomNameCheck = $aArray_RomsListCleaned[$k][0]
		 If $RomName = $RomNameCheck Then
			$MatchLine = $aArray_RomsListCleaned[$k][1]
			MsgBox(16, "Dupe found", "Found duplicate entry on line " & $MatchLine & " and " & $i & @CRLF & $RomName)
			$DupeFound = "TRUE"
		 EndIf
	  Next
	  If $DupeFound = "FALSE" Then
		 _ArrayAdd($aArray_RomsListCleaned, $RomName & "|" & $i )
	  EndIf
	  ConsoleWrite(StringFormat($RomName & "\n"))
	  TrayTip("Indexing XML file", "Row " & $i & "/" & $Rows,5)
   EndIf
Next

 ; This function is called whenever you quit the script.
Func _Quit()
   Exit
EndFunc   ;==>_Quit